#!/usr/bin/tclsh

# begin   11/10/03
# author  Rohit Kaul
# email   rohitkaul@sbcglobal.net

# Version 0.1

# License
# -------
# GPL

# Warranty
# --------
# Absolutely none! Use at your own risk!

source config.tcl

######################################################################
# Procs
######################################################################

proc isValid { num icon path } {
	set val -1
	scan $num %d val
    set res 0
    if { $val >= 0 && $val < 10000 } {
    	set res 1
    }

    if { $res == 0 } {
    	return 0;
    } else {

    	set res 0;
        set filePath $path$icon

        if { [file isfile $filePath] } {
        	set res 1
        } else {
            puts "file-name not found: $filePath"
        }

		return $res;
    }
}

proc simplifyLine { line splitChar } {

	set  simLine ""
	set  spChar  " "
	set  tmpl   [string trim $line $splitChar]
	set  tmpl   [split $tmpl $splitChar]

	set count 0
	foreach seq $tmpl {
		set  seq  [lindex $tmpl $count]
		set  seq  [string trim $seq]
		set  simLine $simLine$seq$spChar
		incr count
	}
	return $simLine
}


proc copyNames { csvFile inpPath thmPath outPath } {
upvar baseDir baseDir
upvar themeDir themeDir

    exec mkdir -p $outPath

	set fp [open $csvFile r]
    set icoList [read $fp]
    close $fp

	set icoList [split $icoList "\n"]
	foreach line $icoList {
    	set  icon    [simplifyLine $line ","]
		set  pNum    [lindex $icon 0];
        set  evoIcon [lindex $icon 1];
        set  kdeIcon [lindex $icon 2];

        set  icoPath $inpPath
        if { [file isfile $thmPath$kdeIcon] } {
        	 set icoPath $thmPath
        }

        if { [isValid $pNum $kdeIcon $icoPath] } {
        	exec cp $icoPath$kdeIcon $outPath$evoIcon
            puts -nonewline "."
            flush stdout
		}
	}
}

######################################################################
# Init
######################################################################

    set inp48Dir  "$baseDir/48x48/"
	set inp22Dir  "$baseDir/22x22/"
	set inp16Dir  "$baseDir/16x16/"

    set thm48Dir  "$themeDir/48x48/"
	set thm22Dir  "$themeDir/22x22/"
	set thm16Dir  "$themeDir/16x16/"


	set out48Dir  "images/"
	set out22Dir  "images/buttons/"
	set out16Dir  "images/"

	set csv48     "setup/images48.txt"
	set csv22     "setup/images22.txt"
	set csv16     "setup/images16.txt"

######################################################################
# Run
######################################################################

	exec rm -Rf $out48Dir

    puts " renaming icons "
	copyNames $csv48 $inp48Dir $thm48Dir  $out48Dir
    copyNames $csv22 $inp22Dir $thm22Dir  $out22Dir
    copyNames $csv16 $inp16Dir $thm16Dir  $out16Dir
	puts " done"
# for evolution 1.4 on Mdk 9.1:
# su
# cp -Rf ./images /usr/share/evolution/1.4/

